#!/usr/bin/perl
#
# GalleryScript Database conversion script.
# Use this script to convert your galleryscript 1.0, 1.1 or 1.2 
# database to 1.3 database
#
# Galleryscript.net  2004 - 2005


my $database    = 'database.txt';
my $newdatabase = 'newdatabase.txt';

#######################################################################
use CGI qw/:standard/;
use CGI::Carp qw(fatalsToBrowser);
use strict;
print "Content-type: text/html\n\n";

my @data;
sub BuildDB {
   (my $gal, my $ignoreview) = @_;

   open(DB, "< $database") or Error("Cannot open $database");
   my @dbase = <DB>;
   close (DB);

   my $entry;
   foreach $entry(@dbase) {chomp($entry);}
   my @cols = split(/\|/, $dbase[0]);
   my $numcols = @cols;
   my $numentries = @dbase;
   my $cnt1; my $cnt2;
   for ($cnt1 = 1 ; $cnt1 < $numentries ; $cnt1++)
   {
     my %row;
     my @vals = split(/\|/, $dbase[$cnt1]);
     for ($cnt2 = 0 ; $cnt2 < $numcols ; $cnt2++)
     {
       $row{$cols[$cnt2]} = $vals[$cnt2];
     }
     # put in data array if applicable
     if ($gal eq 'all')
     { 
       if ($ignoreview == 1) { push (@data, \%row); }
       else { push (@data, \%row) if ($row{View} == 1) ;}
     }
     else
     {
        if ($row{'Gallery'} eq $gal) 
        {
          if ($ignoreview == 1) { push (@data, \%row); }    
          else { push (@data, \%row) if ($row{View} == 1) ;}
        }
     }
   }
}

BuildDB('all', 1);
  my $cnt = 1;
  my $entry;

  open(DB, "> $newdatabase") or Error("Cannot open $database");
  print DB "ID|Title|Time|ImageThumb|Image|Image_text|Gallery|Gen1|Gen2|Gen3|View\n";
    
  foreach $entry(@data)
  {
    my $Time = time();
    print DB "$entry->{'ID'}|$entry->{'Title'}|$Time|$entry->{'ImageThumb'}|$entry->{'Image'}|$entry->{'Image_text'}|$entry->{'Gallery'}||||$entry->{'View'}\n";
    $cnt++;
  }
  print <<EOF;
  <p align="center">Database converted !</p>
EOF
close(DB);

sub Error {
   (my $msg) = @_;

   print $msg, "<br>";
   exit(1);
}
